// xsetaseta@gmail.com
// http://www.seta43.netau.net/electro.html
// modificado TEA5767 para RDA5807
// version prueba


#include <Wire.h>


char entrada[30];
char valor[30];
int contador;
boolean stringComplete = false;

byte dato1=49;
byte dato2=117;
byte dato3=0xb0;
byte dato4=0x10;
byte dato5=0x00;

byte rdato[7];

byte volumen;
unsigned int registro16[10];

void setup()
{
Wire.begin();
setFrequencia();
void setFrequencia();
Serial.begin(9600);
Serial.print("RADIO\n");
Serial.print("RADIO\n");
registro16[5]=0x84DF;

RDA5807_WriteReg(5,registro16[5]);

}

void serialEvent()
{
  while (Serial.available())
  {
    char inChar = (char)Serial.read(); 
    entrada[contador]=inChar;  
    if (inChar == 10)
        {
          stringComplete = true;
          entrada[contador]=0;
          break;
        } 
    contador++;   
  }
}



void loop()
{

if (stringComplete) 
    {
      WriteComand();
    }

}



void Wire_write16(unsigned int val)
{
  Wire.write(val >> 8); Wire.write(val & 0xFF);
}

int RDA5807_WriteReg(byte reg,unsigned int valor)
{
  Wire.beginTransmission(0x11);
  Wire.write(reg); Wire_write16(valor);
  return Wire.endTransmission();
}


void WriteComand()
{
    if(strstr(entrada,"VOLUM="))
      {
        Serial.print("VOLUMx ");
        volumen=getvalor();  
        registro16[5]= (registro16[5] & 0xFFF0) | volumen;
        RDA5807_WriteReg(5,registro16[5]);
        goto salir1;
      }
    if(strstr(entrada,"DATO1="))
      {
        Serial.print("DATO1x ");
        dato1=getvalor();        
        goto salir1;
      }
        
    if(strstr(entrada,"DATO2="))
      {
        Serial.print("DATO2x ");
        dato2=getvalor();
        goto salir1;
      }
     if(strstr(entrada,"DATO3="))
      {
        Serial.print("DATO3x ");
        dato3=getvalor();        
        goto salir1;
      }
        
    if(strstr(entrada,"DATO4="))
      {
        Serial.print("DATO4x ");
        dato4=getvalor();
        goto salir1;
      }
    if(strstr(entrada,"DATO5="))
      {
        Serial.print("DATO5x ");
        dato5=getvalor();
        goto salir1;
      }
      
    if(strstr(entrada,"RATO1="))
      {
        Serial.print("RATO1x=");
        getDatos();
        Serial.println(rdato[1]);
        goto salir0;
      }
    
    if(strstr(entrada,"RATO2="))
      {
        Serial.print("RATO2x=");
        getDatos();
        Serial.println(rdato[2]);
        goto salir0;
      }   
    if(strstr(entrada,"RATO3="))
      {
        Serial.print("RATO3x=");
        getDatos();
        Serial.println(rdato[3]);
        goto salir0;
      }
    if(strstr(entrada,"RATO4="))
      {
        Serial.print("RATO4x=");
        getDatos();
        Serial.println(rdato[4]);
        goto salir0;
      }   
    if(strstr(entrada,"RATO5="))
      {
        Serial.print("RATO5x=");
        getDatos();
        Serial.println(rdato[5]);
        goto salir0;
      }
    if(strstr(entrada,"RADIO1="))
      {
        Serial.println("OK");
        goto salir0;
      }
    if(strstr(entrada,"SEARCHU"))
      {
        Serial.println("OK__UP");
        SearchUP();
        goto salir0;
      }
    if(strstr(entrada,"SEARCHD"))
      {
        Serial.println("OK_DOWN");
        SearchDOWN();
        goto salir0;
      }         
    
    Serial.print("Error");
    Serial.print("->");
    Serial.println(entrada);
    goto salir0;
salir1:
    setFrequencia();
    Serial.print(dato1);
    Serial.print(" ");
    Serial.print(dato2);
    Serial.print(" ");
    Serial.print(dato3);
    Serial.print(" ");
    Serial.print(dato4);
    Serial.print(" ");
    Serial.println(dato5);
salir0:
    contador=0;
    stringComplete = false;      
}


void SearchUP()
{
  dato1=dato1 | 0x40;
  
  dato3=0;
  dato3=dato3 | 0x80;
  dato3=dato3 | 0x60;
  dato3=dato3 | 0x10;
  
  setFrequencia();
  
}

void SearchDOWN()
{
  dato1=dato1 | 0x40;
  
  dato3=0;
//  dato3=dato3 | 0x80;
  dato3=dato3 | 0x60;
  dato3=dato3 | 0x10;
  
  setFrequencia();
}


int getvalor()
{
 int z,zz;

 for(z=6,zz=0;z<10;z++,zz++)
          {
            valor[zz]=entrada[z];
            if(entrada[z]  == 0)
              {
               valor[zz]=0;
               break; 
              }                
          } 
 return atoi(valor) ;
}


void setFrequencia()
{
 delay(100); 
 Wire.beginTransmission(0x60);
 Wire.write(dato1);
 Wire.write(dato2);
 Wire.write(dato3);
 Wire.write(dato4);
 Wire.write(dato5);
 Wire.endTransmission();
 delay(100);
}

void getDatos()
{
  Wire.requestFrom(0x60,5); //reading TEA5767
  if (Wire.available()) 
    {
      for (int i=1; i<6; i++)
         {
           rdato[i]= Wire.read();
//           Serial.print(rdato[i]);
         }
    }
}


