//XSETASETA@GMAIL.COM
//SETA43

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"
#include <unistd.h>


#include "main.h"


char Binput[100];
char Binput2[10];
int  ContadorI;

//_________________________
float frecuency;
long int frecuenciaB;
unsigned char frecuenciaH,frecuenciaL;
unsigned char dato1,dato2,dato3,dato4,dato5;
unsigned char gdato1,gdato2,gdato3,gdato4,gdato5;

float mem1,mem2,mem3,mem4,mem5,mem6,mem7,mem8,mem9,mem10;

//______________________________

void PrintPort(char *cadena)
{
	int z;
	z=strlen(cadena);
	if(DEBUG)printf("Print port >%s\n",cadena);
#if YesWindows							                
					 WriteSerie(hSerial,cadena,z);
					SDL_Delay(80);			//PAUSAR PARA QUE ARDUINO PROCESE TODOS LOS DATOS				 
#else					
					 write(fdrs232,cadena,z);
					SDL_Delay(80);			//PAUSAR PARA QUE ARDUINO PROCESE TODOS LOS DATOS
#endif					

}
void setData(unsigned char num,unsigned char c)
{
	sprintf(VARI,"DATO%d=%d\n",num,c); PrintPort(VARI);
}	

void Frecu_Change(void)
{
		frecuenciaB = 4 * (frecuency * 1000000 + 225000) / 32768;
		frecuenciaH = frecuenciaB >> 8;
		frecuenciaL = frecuenciaB & 0xFF;
		dato1 = frecuenciaH;
		dato2 = frecuenciaL;
		setData(1,dato1);
		setData(2,dato2);
		if(DEBUG)printf("Frecuencia %.2f  dato1=%d   dato2=%d\n",frecuency,dato1,dato2);
}


void formatFrecu(void)  
{
	sprintf(VARI,"%.2f",frecuency);
	TextEntrada(0,VARI);
	Frecu_Change();
}
/*
void PrintTextS(int num,char *string)
{
	sprintf(VARI,"%s",string);
	TextEntrada(num,VARI);
	
}
 */
void PrintTextI(int num,int n)
{
	sprintf(VARI,"%d",n);
	TextEntrada(num,VARI);
}

void PrintTextF(int num,float f)
{
	sprintf(VARI,"%.2f",f);
	TextEntrada(num,VARI);
}

void PrintTextAll(void)
{
		PrintTextF(1,mem1);
		PrintTextF(2,mem2);
		PrintTextF(3,mem3);
		PrintTextF(4,mem4);
		PrintTextF(5,mem5);
		PrintTextF(6,mem6);
		PrintTextF(7,mem7);
		PrintTextF(8,mem8);
		PrintTextF(9,mem9);
		PrintTextF(10,mem10);
		formatFrecu();
} 

int SearchPort()
{
 int z,zz,nbytes;
 #if YesWindows
       for (z=0;z<11;z++)
 #else
       for (z=0;z<7;z++)
 #endif		
		{
		 MODEMDEVICE=myport[z];
		 if(DEBUG)printf("Port %s\n",MODEMDEVICE);
         if(0==IniRs232())
           {
               SDL_Delay(1000);
               PrintPort("\n\n");
               PrintPort("RADIO1=\n");

               ContadorI=0;
               for(zz=0;zz<10;zz++)
                {
                    SDL_Delay(200);
#if YesWindows
                    while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
		            while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif		
		                    {	
							 if(DEBUG)printf("Leer %d -> %s\n",nbytes,Binput2);
                      		 Binput[ContadorI]=Binput2[0];
                         	 ContadorI++;
                         	 if (Binput2[0] == '\n')
                                {
			                     if(ContadorI<2)ContadorI=2;   
                                 Binput[ContadorI-1]=0;
                       	         ContadorI=0;	
                                 sprintf(VARI,"%s",Binput);
                                 if(!strncmp(VARI,"OK",2))
                                   {
                                    printf("Radio found at %s\n",MODEMDEVICE);
                                    CloseRs232();
                                    return z;
                                   }			
                                }
                             }	  	  
                 }             
            }
		 CloseRs232();
		}
    printf("Radio no found \n");
    return -1;
}

//_________________________

Uint32 TimeLeft(void)
{
    static Uint32 next_time = 0;
    Uint32 now;

    now = SDL_GetTicks();
    if ( next_time <= now ) {
        next_time = now+TICK_INTERVAL;
        return(0);
    }
    return(next_time-now);
}


int load_files()
{
    background = load_image( "modelo2.png" );
    if( background == NULL )  return 0;
 
	dots = load_image( "modelo1.png" );
    if( dots == NULL )  return 0;

    font = TTF_OpenFont( "seta.ttf", 20 );
	if( font == NULL )
    {
		printf("Error cargando Font\n");
        return 0;
    }
	// Cargamos sonido
	if(SONIDO)sonido = Mix_LoadWAV("modelo.wav");
 	if(SONIDO)if ( sonido == NULL )
		{
		 printf("No pude cargar sonido: %s\n", Mix_GetError());
//     	 return 0;
 		}
  return 1;
}

void RepintarPantalla()
{
    SDL_WM_SetCaption( "IC_TEA5767_SDL", NULL );
	apply_surface( 0, 0, background, screen );
 /*   message = TTF_RenderText_Solid( font, "RADIO IC_TEA5767", textColor );
	apply_surface( 200,1, message, screen );
*/	
	PaintBotones();
	PaintLuces();
	PaintEntradas();
	PaintTextos();
	PrintTextAll();
	SDL_Flip( screen );
}



void ProcesoEntradas()
{
 char cadena[30];
 int z;
	if(!strncmp(VARI,"RATO4=",5)) 
		{
			strcpy(cadena,VARI+7);			
			gdato4=atoi(cadena);
//			printf("ValorDATO4=%d\n",gdato4);
			z=gdato4>>4;
			z*=66; z=z/10;
			PrintTextI(11,z);
			if(DEBUG)printf("Signal %d\n",z);	
			goto salir;					
		}
	if(!strncmp(VARI,"RATO3=",5)) 
		{
			strcpy(cadena,VARI+7);			
			gdato3=atoi(cadena);
//			printf("ValorDATO3=%d\n",gdato3);
			z=gdato4 & 128;
			if(z>0)
				nluz[0].estado=1;
			  else
				nluz[0].estado=0;
			PaintLuces();
			if(DEBUG)printf("Stereo %d\n",z);
			goto salir;							
		}
	return;
 salir:	
	SDL_Flip( screen );
	return;			
}	
	
int main (int argc, char *argv[])
{
 int quit = 0;
 int mouse_x,mouse_y;
 Uint8 *teclas; 
 int zboton=0;
 int z;

 int nbytes;
 int canal;
 
//_____________________________
	char bmemory=0;
	char bmute=0;
	

	dato1 = 49;
	dato2 = 117;
	dato3 = 0x10;
	dato4 = 0x10;
	dato5 = 0x00;
	
	mem1 = 103.5;
	mem2 = 96.2;
	mem3 = 88;
	mem4 = 94.7;
	mem5 = 101.9;
	mem6 = 99.8;
	mem7 = 89.6;
	mem8 = 95; 
	mem9 = 96;
	mem10 = 97;
 
 //_____________________________

 	printf("SDL_RADIO\n");

#if YesWindows 
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
#endif

    printf("%s\n",argv[0]);
	

	if(argc==2)
		{
		 printf("%s\n",argv[1]);
 	 	 MODEMDEVICE=argv[1];
		}
	 else
		{
		 z=SearchPort();
		 if(z==-1)
			{			
			 printf("No RADIO %d\n",z);
			 goto salir;
			}
		 MODEMDEVICE=myport[z]; 
		}
	if(0!=IniRs232())
		{		 
		 printf("No RADIO.\n");
		 goto salir;
		}
	SDL_Delay(1000);	
	
	Initextos();
	Inibotones();
	IniLuces ();
	Inientradas();

			
    if( init() == 0 ) return 1;	
    if( load_files() == 0 ) return 2;	
	RepintarPantalla();	
	if( SDL_Flip( screen ) == -1 ) return 3;
	if(SONIDO)canal = Mix_PlayChannel(-1, sonido, 0);

#if YesWindows 
    printf("MODO WINDOWS\n");
    PurgeComm(hSerial,PURGE_RXCLEAR | PURGE_TXCLEAR);//Vacia buffer 
    SDL_Delay(1500);
#else
    printf("MODO LINUX\n");
	while(( nbytes = read(fdrs232, Binput2, 1)>0 )); //Vacia buffer
#endif
	
	//SDL_Delay(1000);			
	PrintPort("RADIO1=\n");	
	setData(1,dato1);
	setData(2,dato2);
	setData(3,dato3);
	setData(4,dato4);
	setData(5,dato5);	
	frecuency=mem1;
	RepintarPantalla();

    ContadorI=0;
	while( quit == 0 )
    {	
	  SDL_Delay(200);

#if YesWindows
         while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
		 while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif		
		{
		 // printf("Leer %d -> %s\n",nbytes,Binput2);	
		 Binput[ContadorI]=Binput2[0];
		 ContadorI++;
	  	 if (Binput2[0] == '\n')
           {
			if(ContadorI<2)ContadorI=2;   
          	Binput[ContadorI-1]=0;
		  	ContadorI=0;	
  			if(DEBUG)printf("Leidos-> %s\n",Binput);
			sprintf(VARI,"%s",Binput);
			ProcesoEntradas();
       	   } 
		}	
						
		  	  
	  if(!TimeLeft())
 	                {
					 PrintPort("RATO4=\n");
					 PrintPort("RATO3=\n");
	                 //if(DEBUG)printf("time\n");				
                    }
	  while( SDL_PollEvent( &event ) )
        {
			teclas = SDL_GetKeyState(NULL);
			if(teclas[SDLK_ESCAPE] )
				{
					dato1=dato1 | 128;
					setData(1,dato1);
					dato4=80;							
					setData(4,dato4);
					printf("Fin programa...Stand-by\n");
					goto salir;
				}
            if( event.type == SDL_QUIT )   quit = 1;
            if( event.type == SDL_KEYDOWN ) 
			{
				if(DEBUG)printf("Evento Tecla\n");
				if(event.key.keysym.sym == SDLK_f)
                    {  
          #if YesWindows
                     screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
          #else
                     SDL_WM_ToggleFullScreen(screen);
          #endif  
                     RepintarPantalla();
                    }
				if(event.key.keysym.sym == SDLK_m)
				 {
					screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );
					RepintarPantalla();
				 }
			}
			if( event.type == SDL_MOUSEBUTTONDOWN ) {
				mouse_x=event.button.x;
				mouse_y=event.button.y;
				zboton=DetecBotones(mouse_x,mouse_y);
				if(zboton!=-1)
					{               
					if(zboton!=16)
						{
						nluz[1].estado=0;  	
						}
                 	 switch (zboton)
                        {                         
                         case 0: 
							dato1=dato1 | 128;
							setData(1,dato1);
							dato4=80;							
							setData(4,dato4);
							printf("END program...Stand-by\n");
							goto salir;
                         break;    
						 case 1:                            
                            frecuency+=0.1;
                            if(frecuency>108) frecuency=108;
                            formatFrecu();PrintPort("RATO4=\n"); goto salto1;
                         break;                               
                         case 2:
                            frecuency-=0.1;
                             if(frecuency<87.5) frecuency=87.5;
                             formatFrecu();PrintPort("RATO4=\n"); goto salto1;
                         break; 
                         case 3:
                            frecuency-=1;
                             if(frecuency<87.5) frecuency=87.5;
                             formatFrecu();PrintPort("RATO4=\n"); goto salto1;
                         break; 
                         case 4:
                            frecuency+=1;
                            if(frecuency>108) frecuency=108;
                            formatFrecu();PrintPort("RATO4=\n"); goto salto1;
                         break; 
                         case 5:
							if(bmute==1)
								{
								bmute=0;
								nluz[2].estado=0;
								dato1 = dato1 & 127;
								}
							  else
								{
								bmute=1;								 
								nluz[2].estado=1;
								dato1 = dato1 | 128;
								}
							setData(1,dato1);
							goto salto1;									 
                         break;
                         case 6:
							if(bmemory==1)								
								 mem1=frecuency;
								else								
								 frecuency=mem1;
							bmemory=0; 								            
                         break; 
                         case 7:
							if(bmemory==1)								
								 mem2=frecuency;
								else								
								 frecuency=mem2;
							bmemory=0; 								 														                          
                         break;
                         case 8:
							if(bmemory==1)								
								 mem3=frecuency;
								else								
								 frecuency=mem3;
							bmemory=0; 
                         break;
                         case 9:
							if(bmemory==1)								
								 mem4=frecuency;
								else								
								 frecuency=mem4;								                    
							bmemory=0; 
                         break;
                         case 10:
							if(bmemory==1)								
								 mem5=frecuency;
								else								
								 frecuency=mem5;
							bmemory=0; 
                         break; 
                        case 11:
							if(bmemory==1)								
								 mem6=frecuency;
								else								
								 frecuency=mem6;
							bmemory=0; 
                         break;                          
                         case 12:
							if(bmemory==1)								
								 mem7=frecuency;
								else								
								 frecuency=mem7;
							bmemory=0; 
                         break; 
                        case 13:
							if(bmemory==1)								
								 mem8=frecuency;
								else								
								 frecuency=mem8;
							bmemory=0; 
                         break;                
                        case 14:
							if(bmemory==1)								
								 mem9=frecuency;
								else								
								 frecuency=mem9;
							bmemory=0; 
                         break;                
                        case 15:
							if(bmemory==1)								
								 mem10=frecuency;
								else								
								 frecuency=mem10;
							bmemory=0; 
                         break; 
                         
                         case 16:
                            if(bmemory==1)
								{
								bmemory=0;
								nluz[1].estado=0;
								}
							  else
								{
								bmemory=1;
								nluz[1].estado=1;
								}								
                         break; 
						 case 18:
                            
                         break; 
						 case 19:
                           
                         break; 
                        default:  
							if(SONIDO)canal = Mix_PlayChannel(-1, sonido, 0);						
							printf(">.>%s\n",VARI);					
                        } 
                     PrintTextAll();
salto1:                     
                     PaintLuces();        
					 PaintBoton(zboton,1);
					 SDL_Flip( screen );
					}
					if(DEBUG)printf("Evento Raton X=%d Y=%d Boton=%d\n",mouse_x,mouse_y,zboton);					
			}
			if( event.type == SDL_MOUSEBUTTONUP ) 
			  {
				if(zboton!=-1)
					{
                    SDL_Delay(100);
					PaintBotones();
					PaintLuces();
					SDL_Flip( screen );
					}
									
					if(DEBUG)printf("RepintarBoton %d\n",zboton);
					zboton=-1;					
			  }
        }
	}
		
	
salir: 
     //Cerrar todo el SDL
    clean_up();
    SDL_Delay(1000);
	CloseRs232();
    return 0;  
}

//____________________FIN____________
